diff --git a/usr.sbin/bthidd/parser.y b/usr.sbin/bthidd/parser.y
new file mode 100644
index 0000000000..8ff9206add
--- /dev/null
+++ b/usr.sbin/bthidd/parser.y
@@ -0,0 +1,475 @@
+%{
+/*
+ * parser.y
+ */
+
+/*-
+ * Copyright (c) 2006 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: parser.y,v 1.7 2006/09/07 21:06:53 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidd/parser.y 235789 2012-05-22 16:33:10Z bapt $
+ */
+
+#include <sys/queue.h>
+#include <bluetooth.h>
+#include <bus/u4b/usb.h>
+#include <bus/u4b/usbhid.h>
+#include <errno.h>
+#include <limits.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <usbhid.h>
+
+#ifndef BTHIDCONTROL
+#include <stdarg.h>
+#include <syslog.h>
+#define	SYSLOG		syslog
+#define	LOGCRIT		LOG_CRIT
+#define	LOGERR		LOG_ERR
+#define	LOGWARNING	LOG_WARNING
+#define	EOL
+#else
+#define	SYSLOG		fprintf
+#define	LOGCRIT		stderr
+#define	LOGERR		stderr
+#define	LOGWARNING	stderr
+#define	EOL	"\n"
+#endif /* ndef BTHIDCONTROL */
+
+#include "bthid_config.h"
+
+	int	yylex		(void);
+	void	yyerror		(char const *);
+static	int32_t	check_hid_device(hid_device_p hid_device);
+static	void	free_hid_device	(hid_device_p hid_device);
+
+extern	FILE			*yyin;
+extern	int			 yylineno;
+	char const		*config_file = BTHIDD_CONFFILE;
+	char const		*hids_file   = BTHIDD_HIDSFILE;
+
+static	char			 buffer[1024];
+static	int32_t			 hid_descriptor_size;
+static	hid_device_t		*hid_device = NULL;
+static	LIST_HEAD(, hid_device)	 hid_devices;
+
+%}
+
+%union {
+	bdaddr_t	bdaddr;
+	int32_t		num;
+}
+
+%token <bdaddr> T_BDADDRSTRING
+%token <num>	T_HEXBYTE
+%token T_DEVICE T_BDADDR T_CONTROL_PSM T_INTERRUPT_PSM T_RECONNECT_INITIATE
+%token T_BATTERY_POWER T_NORMALLY_CONNECTABLE T_HID_DESCRIPTOR
+%token T_TRUE T_FALSE T_ERROR
+
+%%
+
+config:		line
+		| config line
+		;
+
+line:		T_DEVICE
+			{
+			hid_device = (hid_device_t *) calloc(1, sizeof(*hid_device));
+			if (hid_device == NULL) {
+				SYSLOG(LOGCRIT, "Could not allocate new " \
+						"config entry" EOL);
+				YYABORT;
+			}
+
+			hid_device->new_device = 1;
+			}
+		'{' options '}'
+			{
+			if (check_hid_device(hid_device))
+				LIST_INSERT_HEAD(&hid_devices,hid_device,next);
+			else
+				free_hid_device(hid_device);
+
+			hid_device = NULL;
+			}
+		;
+
+options:	option ';'
+		| options option ';'
+		;
+
+option:		bdaddr
+		| control_psm
+		| interrupt_psm
+		| reconnect_initiate
+		| battery_power
+		| normally_connectable
+		| hid_descriptor
+		| parser_error
+		;
+
+bdaddr:		T_BDADDR T_BDADDRSTRING
+			{
+			memcpy(&hid_device->bdaddr, &$2, sizeof(hid_device->bdaddr));
+			}
+		;
+
+control_psm:	T_CONTROL_PSM T_HEXBYTE
+			{
+			hid_device->control_psm = $2;
+			}
+		;
+
+interrupt_psm:	T_INTERRUPT_PSM T_HEXBYTE
+			{
+			hid_device->interrupt_psm = $2;
+			}
+		;
+
+reconnect_initiate: T_RECONNECT_INITIATE T_TRUE
+			{
+			hid_device->reconnect_initiate = 1;
+			}
+		| T_RECONNECT_INITIATE T_FALSE
+			{
+			hid_device->reconnect_initiate = 0;
+			}
+		;
+
+battery_power:	T_BATTERY_POWER T_TRUE
+			{
+			hid_device->battery_power = 1;
+			}
+		| T_BATTERY_POWER T_FALSE
+			{
+			hid_device->battery_power = 0;
+			}
+		;
+
+normally_connectable: T_NORMALLY_CONNECTABLE T_TRUE
+			{
+			hid_device->normally_connectable = 1;
+			}
+		| T_NORMALLY_CONNECTABLE T_FALSE
+			{
+			hid_device->normally_connectable = 0;
+			}
+		;
+
+hid_descriptor:	T_HID_DESCRIPTOR	
+			{
+			hid_descriptor_size = 0;
+			}
+		'{' hid_descriptor_bytes '}'
+			{
+			if (hid_device->desc != NULL)
+				hid_dispose_report_desc(hid_device->desc);
+
+			hid_device->desc = hid_use_report_desc((unsigned char *) buffer, hid_descriptor_size);
+			if (hid_device->desc == NULL) {
+				SYSLOG(LOGCRIT, "Could not use HID descriptor" EOL);
+				YYABORT;
+			}
+			}
+		;
+
+hid_descriptor_bytes: hid_descriptor_byte
+		| hid_descriptor_bytes hid_descriptor_byte
+		;
+
+hid_descriptor_byte: T_HEXBYTE
+			{
+			if (hid_descriptor_size >= (int32_t) sizeof(buffer)) {
+				SYSLOG(LOGCRIT, "HID descriptor is too big" EOL);
+				YYABORT;
+			}
+
+			buffer[hid_descriptor_size ++] = $1;
+			}
+		;
+
+parser_error:	T_ERROR
+			{
+				YYABORT;
+			}
+
+%%
+
+/* Display parser error message */
+void
+yyerror(char const *message)
+{
+	SYSLOG(LOGERR, "%s in line %d" EOL, message, yylineno); 
+}
+
+/* Re-read config file */
+int32_t
+read_config_file(void)
+{
+	int32_t	e;
+
+	if (config_file == NULL) {
+		SYSLOG(LOGERR, "Unknown config file name!" EOL);
+		return (-1);
+	}
+
+	if ((yyin = fopen(config_file, "r")) == NULL) {
+		SYSLOG(LOGERR, "Could not open config file '%s'. %s (%d)" EOL,
+				config_file, strerror(errno), errno);
+		return (-1);
+	}
+
+	clean_config();
+	if (yyparse() < 0) {
+		SYSLOG(LOGERR, "Could not parse config file '%s'" EOL,
+				config_file);
+		e = -1;
+	} else
+		e = 0;
+
+	fclose(yyin);
+	yyin = NULL;
+
+	return (e);
+}
+
+/* Clean config */
+void
+clean_config(void)
+{
+	while (!LIST_EMPTY(&hid_devices)) {
+		hid_device_p	d = LIST_FIRST(&hid_devices);
+
+		LIST_REMOVE(d, next);
+		free_hid_device(d);
+	}
+}
+
+/* Lookup config entry */
+hid_device_p
+get_hid_device(bdaddr_p bdaddr)
+{
+	hid_device_p	d;
+
+	LIST_FOREACH(d, &hid_devices, next)
+		if (memcmp(&d->bdaddr, bdaddr, sizeof(bdaddr_t)) == 0)
+			break;
+
+	return (d);
+}
+
+/* Get next config entry */
+hid_device_p
+get_next_hid_device(hid_device_p d)
+{
+	return ((d == NULL)? LIST_FIRST(&hid_devices) : LIST_NEXT(d, next));
+}
+
+/* Print config entry */
+void
+print_hid_device(hid_device_p d, FILE *f)
+{
+	/* XXX FIXME hack! */
+	struct report_desc {
+		unsigned int	size;
+		unsigned char	data[1];
+	};
+	/* XXX FIXME hack! */
+
+	struct report_desc	*desc = (struct report_desc *) d->desc;
+	uint32_t		 i;
+
+	fprintf(f,
+"device {\n"					\
+"	bdaddr			%s;\n"		\
+"	control_psm		0x%x;\n"	\
+"	interrupt_psm		0x%x;\n"	\
+"	reconnect_initiate	%s;\n"		\
+"	battery_power		%s;\n"		\
+"	normally_connectable	%s;\n"		\
+"	hid_descriptor		{",
+		bt_ntoa(&d->bdaddr, NULL),
+		d->control_psm, d->interrupt_psm,
+                d->reconnect_initiate? "true" : "false",
+                d->battery_power? "true" : "false",
+                d->normally_connectable? "true" : "false");
+ 
+	for (i = 0; i < desc->size; i ++) {
+			if ((i % 8) == 0)
+				fprintf(f, "\n		");
+ 
+			fprintf(f, "0x%2.2x ", desc->data[i]);
+	}
+                
+	fprintf(f,
+"\n"		\
+"	};\n"	\
+"}\n");
+}
+
+/* Check config entry */
+static int32_t
+check_hid_device(hid_device_p d)
+{
+	hid_data_t	hd;
+	hid_item_t	hi;
+	int32_t		page;
+
+	if (get_hid_device(&d->bdaddr) != NULL) {
+		SYSLOG(LOGERR, "Ignoring duplicated entry for bdaddr %s" EOL,
+				bt_ntoa(&d->bdaddr, NULL));
+		return (0);
+	}
+
+	if (d->control_psm == 0) {
+		SYSLOG(LOGERR, "Ignoring entry with invalid control PSM" EOL);
+		return (0);
+	}
+
+	if (d->interrupt_psm == 0) {
+		SYSLOG(LOGERR, "Ignoring entry with invalid interrupt PSM" EOL);
+		return (0);
+	}
+
+	if (d->desc == NULL) {
+		SYSLOG(LOGERR, "Ignoring entry without HID descriptor" EOL);
+		return (0);
+	}
+
+	/* XXX somehow need to make sure descriptor is valid */
+	for (hd = hid_start_parse(d->desc, ~0, -1); hid_get_item(hd, &hi) > 0; ) {
+		switch (hi.kind) {
+		case hid_collection:
+		case hid_endcollection:
+		case hid_output:
+		case hid_feature:
+			break;
+
+		case hid_input:
+			/* Check if the device may send keystrokes */
+			page = HID_PAGE(hi.usage);
+			if (page == HUP_KEYBOARD)
+				d->keyboard = 1;
+			break;
+		}
+	}
+	hid_end_parse(hd);
+
+	return (1);
+}
+
+/* Free config entry */
+static void
+free_hid_device(hid_device_p d)
+{
+	if (d->desc != NULL)
+		hid_dispose_report_desc(d->desc);
+
+	memset(d, 0, sizeof(*d));
+	free(d);
+}
+
+/* Re-read hids file */
+int32_t
+read_hids_file(void)
+{
+	FILE		*f;
+	hid_device_t	*d;
+	char		*line;
+	bdaddr_t	 bdaddr;
+	int32_t		 lineno;
+
+	if (hids_file == NULL) {
+		SYSLOG(LOGERR, "Unknown HIDs file name!" EOL);
+		return (-1);
+	}
+
+	if ((f = fopen(hids_file, "r")) == NULL) {
+		if (errno == ENOENT)
+			return (0);
+
+		SYSLOG(LOGERR, "Could not open HIDs file '%s'. %s (%d)" EOL,
+			hids_file, strerror(errno), errno);
+		return (-1);
+	}
+
+	for (lineno = 1; fgets(buffer, sizeof(buffer), f) != NULL; lineno ++) {
+		if ((line = strtok(buffer, "\r\n\t ")) == NULL)
+			continue; /* ignore empty lines */
+
+		if (!bt_aton(line, &bdaddr)) {
+			SYSLOG(LOGWARNING, "Ignoring unparseable BD_ADDR in " \
+				"%s:%d" EOL, hids_file, lineno);
+			continue;
+		}
+
+		if ((d = get_hid_device(&bdaddr)) != NULL)
+			d->new_device = 0;
+	}
+
+	fclose(f);
+
+	return (0);
+}
+
+/* Write hids file */
+int32_t
+write_hids_file(void)
+{
+	char		 path[PATH_MAX];
+	FILE		*f;
+	hid_device_t	*d;
+
+	if (hids_file == NULL) {
+		SYSLOG(LOGERR, "Unknown HIDs file name!" EOL);
+		return (-1);
+	}
+
+	snprintf(path, sizeof(path), "%s.new", hids_file);
+
+	if ((f = fopen(path, "w")) == NULL) {
+		SYSLOG(LOGERR, "Could not open HIDs file '%s'. %s (%d)" EOL,
+			path, strerror(errno), errno);
+		return (-1);
+	}
+
+	LIST_FOREACH(d, &hid_devices, next)
+		if (!d->new_device)
+			fprintf(f, "%s\n", bt_ntoa(&d->bdaddr, NULL));
+
+	fclose(f);
+
+	if (rename(path, hids_file) < 0) {
+		SYSLOG(LOGERR, "Could not rename new HIDs file '%s' to '%s'. " \
+			"%s (%d)" EOL, path, hids_file, strerror(errno), errno);
+		unlink(path);
+		return (-1);
+	}
+
+	return (0);
+}
+
diff --git a/usr.sbin/bthidd/server.c b/usr.sbin/bthidd/server.c
new file mode 100644
index 0000000000..92992eaed3
--- /dev/null
+++ b/usr.sbin/bthidd/server.c
@@ -0,0 +1,349 @@
+/*
+ * server.c
+ */
+
+/*-
+ * Copyright (c) 2006 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: server.c,v 1.9 2006/09/07 21:06:53 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidd/server.c 162494 2006-09-21 02:32:28Z emax $
+ */
+
+#include <sys/queue.h>
+#include <assert.h>
+#include <bluetooth.h>
+#include <dev/vkbd/vkbd_var.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+#include <usbhid.h>
+#include "bthid_config.h"
+#include "bthidd.h"
+#include "kbd.h"
+
+#undef	max
+#define	max(x, y)	(((x) > (y))? (x) : (y))
+
+static int32_t	server_accept (bthid_server_p srv, int32_t fd);
+static int32_t	server_process(bthid_server_p srv, int32_t fd);
+
+/*
+ * Initialize server
+ */
+
+int32_t
+server_init(bthid_server_p srv)
+{
+	struct sockaddr_l2cap	l2addr;
+
+	assert(srv != NULL);
+
+	srv->ctrl = srv->intr = -1;
+	FD_ZERO(&srv->rfdset);
+	FD_ZERO(&srv->wfdset);
+	LIST_INIT(&srv->sessions);
+
+	/* Open /dev/consolectl */
+	srv->cons = open("/dev/consolectl", O_RDWR);
+	if (srv->cons < 0) {
+		syslog(LOG_ERR, "Could not open /dev/consolectl. %s (%d)",
+			strerror(errno), errno);
+		return (-1);
+	}
+
+	/* Create control socket */
+	srv->ctrl = socket(PF_BLUETOOTH, SOCK_SEQPACKET, BLUETOOTH_PROTO_L2CAP);
+	if (srv->ctrl < 0) {
+		syslog(LOG_ERR, "Could not create control L2CAP socket. " \
+			"%s (%d)", strerror(errno), errno);
+		close(srv->cons);
+		return (-1);
+	}
+
+	l2addr.l2cap_len = sizeof(l2addr);
+	l2addr.l2cap_family = AF_BLUETOOTH;
+	memcpy(&l2addr.l2cap_bdaddr, &srv->bdaddr, sizeof(l2addr.l2cap_bdaddr));
+	l2addr.l2cap_psm = htole16(0x11);
+
+	if (bind(srv->ctrl, (struct sockaddr *) &l2addr, sizeof(l2addr)) < 0) {
+		syslog(LOG_ERR, "Could not bind control L2CAP socket. " \
+			"%s (%d)", strerror(errno), errno);
+		close(srv->ctrl);
+		close(srv->cons);
+		return (-1);
+	}
+
+	if (listen(srv->ctrl, 10) < 0) {
+		syslog(LOG_ERR, "Could not listen on control L2CAP socket. " \
+			"%s (%d)", strerror(errno), errno);
+		close(srv->ctrl);
+		close(srv->cons);
+		return (-1);
+	}
+
+	/* Create intrrupt socket */
+	srv->intr = socket(PF_BLUETOOTH, SOCK_SEQPACKET, BLUETOOTH_PROTO_L2CAP);
+	if (srv->intr < 0) {
+		syslog(LOG_ERR, "Could not create interrupt L2CAP socket. " \
+			"%s (%d)", strerror(errno), errno);
+		close(srv->ctrl);
+		close(srv->cons);
+		return (-1);
+	}
+
+	l2addr.l2cap_psm = htole16(0x13);
+
+	if (bind(srv->intr, (struct sockaddr *) &l2addr, sizeof(l2addr)) < 0) {
+		syslog(LOG_ERR, "Could not bind interrupt L2CAP socket. " \
+			"%s (%d)", strerror(errno), errno);
+		close(srv->intr);
+		close(srv->ctrl);
+		close(srv->cons);
+		return (-1);
+	}
+
+	if (listen(srv->intr, 10) < 0) {
+		syslog(LOG_ERR, "Could not listen on interrupt L2CAP socket. "\
+			"%s (%d)", strerror(errno), errno);
+		close(srv->intr);
+		close(srv->ctrl);
+		close(srv->cons);
+		return (-1);
+	}
+
+	FD_SET(srv->ctrl, &srv->rfdset);
+	FD_SET(srv->intr, &srv->rfdset);
+	srv->maxfd = max(srv->ctrl, srv->intr);
+
+	return (0);
+}
+
+/*
+ * Shutdown server
+ */
+
+void
+server_shutdown(bthid_server_p srv)
+{
+	assert(srv != NULL);
+
+	close(srv->cons);
+	close(srv->ctrl);
+	close(srv->intr);
+
+	while (!LIST_EMPTY(&srv->sessions))
+		session_close(LIST_FIRST(&srv->sessions));
+
+	memset(srv, 0, sizeof(*srv));
+}
+
+/*
+ * Do one server iteration
+ */
+
+int32_t
+server_do(bthid_server_p srv)
+{
+	struct timeval	tv;
+	fd_set		rfdset, wfdset;
+	int32_t		n, fd;
+
+	assert(srv != NULL);
+
+	tv.tv_sec = 1;
+	tv.tv_usec = 0;
+
+	/* Copy cached version of the fd sets and call select */
+	memcpy(&rfdset, &srv->rfdset, sizeof(rfdset));
+	memcpy(&wfdset, &srv->wfdset, sizeof(wfdset));
+
+	n = select(srv->maxfd + 1, &rfdset, &wfdset, NULL, &tv);
+	if (n < 0) {
+		if (errno == EINTR)  
+			return (0);
+
+		syslog(LOG_ERR, "Could not select(%d, %p, %p). %s (%d)",
+			srv->maxfd + 1, &rfdset, &wfdset, strerror(errno), errno);
+
+		return (-1);
+	}
+
+	/* Process descriptors (if any) */
+	for (fd = 0; fd < srv->maxfd + 1 && n > 0; fd ++) {
+		if (FD_ISSET(fd, &rfdset)) {
+			n --;
+
+			if (fd == srv->ctrl || fd == srv->intr)
+				server_accept(srv, fd);
+			else
+				server_process(srv, fd);
+		} else if (FD_ISSET(fd, &wfdset)) {
+			n --;
+
+			client_connect(srv, fd);
+		}
+	}
+
+	return (0);
+}
+
+/*
+ * Accept new connection 
+ */
+
+static int32_t
+server_accept(bthid_server_p srv, int32_t fd)
+{
+	bthid_session_p		s;
+	hid_device_p		d;
+	struct sockaddr_l2cap	l2addr;
+	int32_t			new_fd;
+	socklen_t		len;
+
+	len = sizeof(l2addr);
+	if ((new_fd = accept(fd, (struct sockaddr *) &l2addr, &len)) < 0) {
+		syslog(LOG_ERR, "Could not accept %s connection. %s (%d)",
+			(fd == srv->ctrl)? "control" : "interrupt",
+			strerror(errno), errno);
+		return (-1);
+	}
+
+	/* Is device configured? */
+	if ((d = get_hid_device(&l2addr.l2cap_bdaddr)) == NULL) {
+		syslog(LOG_ERR, "Rejecting %s connection from %s. " \
+			"Device not configured",
+			(fd == srv->ctrl)? "control" : "interrupt",
+			bt_ntoa(&l2addr.l2cap_bdaddr, NULL));
+		close(new_fd);
+		return (-1);
+	}
+
+	/* Check if we have session for the device */
+	if ((s = session_by_bdaddr(srv, &l2addr.l2cap_bdaddr)) == NULL) {
+		d->new_device = 0; /* reset new device flag */
+		write_hids_file();
+
+		/* Create new inbound session */
+		if ((s = session_open(srv, d)) == NULL) {
+			syslog(LOG_CRIT, "Could not open inbound session "
+				"for %s", bt_ntoa(&l2addr.l2cap_bdaddr, NULL));
+			close(new_fd);
+			return (-1);
+		}
+	}
+
+	/* Update descriptors */
+	if (fd == srv->ctrl) {
+		assert(s->ctrl == -1);
+		s->ctrl = new_fd;
+		s->state = (s->intr == -1)? W4INTR : OPEN;
+	} else {
+		assert(s->intr == -1);
+		s->intr = new_fd;
+		s->state = (s->ctrl == -1)? W4CTRL : OPEN;
+	}
+
+	FD_SET(new_fd, &srv->rfdset);
+	if (new_fd > srv->maxfd)
+		srv->maxfd = new_fd;
+
+	syslog(LOG_NOTICE, "Accepted %s connection from %s",
+		(fd == srv->ctrl)? "control" : "interrupt",
+		bt_ntoa(&l2addr.l2cap_bdaddr, NULL));
+
+	/* Register session's vkbd descriptor (if needed) for read */
+	if (s->state == OPEN && d->keyboard) {
+		assert(s->vkbd != -1);
+
+		FD_SET(s->vkbd, &srv->rfdset);
+		if (s->vkbd > srv->maxfd)
+			srv->maxfd = s->vkbd;
+	}
+
+	return (0);
+}
+
+/*
+ * Process data on the connection
+ */
+
+static int32_t
+server_process(bthid_server_p srv, int32_t fd)
+{
+	bthid_session_p		s = session_by_fd(srv, fd);
+	int32_t			len, to_read;
+	int32_t			(*cb)(bthid_session_p, uint8_t *, int32_t);
+	union {
+		uint8_t		b[1024];
+		vkbd_status_t	s;
+	}			data;
+
+	if (s == NULL)
+		return (0); /* can happen on device disconnect */
+
+
+	if (fd == s->ctrl) {
+		cb = hid_control;
+		to_read = sizeof(data.b);
+	} else if (fd == s->intr) {
+		cb = hid_interrupt;
+		to_read = sizeof(data.b);
+	} else {
+		assert(fd == s->vkbd);
+
+		cb = kbd_status_changed;
+		to_read = sizeof(data.s);
+	}
+
+	do {
+		len = read(fd, &data, to_read);
+	} while (len < 0 && errno == EINTR);
+
+	if (len < 0) {
+		syslog(LOG_ERR, "Could not read data from %s (%s). %s (%d)",
+			bt_ntoa(&s->bdaddr, NULL),
+			(fd == s->ctrl)? "control" : "interrupt",
+			strerror(errno), errno);
+		session_close(s);
+		return (0);
+	}
+
+	if (len == 0) {
+		syslog(LOG_NOTICE, "Remote device %s has closed %s connection",
+			bt_ntoa(&s->bdaddr, NULL),
+			(fd == s->ctrl)? "control" : "interrupt");
+		session_close(s);
+		return (0);
+	}
+
+	(*cb)(s, (uint8_t *) &data, len);
+
+	return (0);
+}
+
diff --git a/usr.sbin/bthidd/session.c b/usr.sbin/bthidd/session.c
new file mode 100644
index 0000000000..cb863fdaa1
--- /dev/null
+++ b/usr.sbin/bthidd/session.c
@@ -0,0 +1,184 @@
+/*
+ * session.c
+ */
+
+/*-
+ * Copyright (c) 2006 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: session.c,v 1.3 2006/09/07 21:06:53 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidd/session.c 162128 2006-09-07 21:47:49Z emax $
+ */
+
+#include <sys/queue.h>
+#include <assert.h>
+#include <bluetooth.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+#include <usbhid.h>
+#include "bthid_config.h"
+#include "bthidd.h"
+#include "kbd.h"
+
+/*
+ * Create new session
+ */
+
+bthid_session_p
+session_open(bthid_server_p srv, hid_device_p const d)
+{
+	bthid_session_p	s;
+
+	assert(srv != NULL);
+	assert(d != NULL);
+
+	if ((s = (bthid_session_p) malloc(sizeof(*s))) == NULL)
+		return (NULL);
+
+	s->srv = srv;  
+	memcpy(&s->bdaddr, &d->bdaddr, sizeof(s->bdaddr));
+	s->ctrl = -1;
+	s->intr = -1;
+
+	if (d->keyboard) {
+		/* Open /dev/vkbdctl */
+		s->vkbd = open("/dev/vkbdctl", O_RDWR);
+		if (s->vkbd < 0) {
+			syslog(LOG_ERR, "Could not open /dev/vkbdctl " \
+				"for %s. %s (%d)", bt_ntoa(&s->bdaddr, NULL),
+				strerror(errno), errno);
+			free(s);
+			return (NULL);
+		}
+	} else
+		s->vkbd = -1;
+
+	s->state = CLOSED;
+
+	s->keys1 = bit_alloc(kbd_maxkey());
+	if (s->keys1 == NULL) {
+		free(s);
+		return (NULL);
+	}
+
+	s->keys2 = bit_alloc(kbd_maxkey());
+	if (s->keys2 == NULL) {
+		free(s->keys1);
+		free(s);
+		return (NULL);
+	}
+
+	LIST_INSERT_HEAD(&srv->sessions, s, next);
+
+	return (s);
+}
+
+/*
+ * Lookup session by bdaddr
+ */
+
+bthid_session_p
+session_by_bdaddr(bthid_server_p srv, bdaddr_p bdaddr)
+{
+	bthid_session_p	s;
+
+	assert(srv != NULL);
+	assert(bdaddr != NULL);
+
+	LIST_FOREACH(s, &srv->sessions, next)
+		if (memcmp(&s->bdaddr, bdaddr, sizeof(s->bdaddr)) == 0)
+			break;
+
+	return (s);
+}
+
+/*
+ * Lookup session by fd
+ */
+
+bthid_session_p
+session_by_fd(bthid_server_p srv, int32_t fd)
+{
+	bthid_session_p	s;
+
+	assert(srv != NULL);
+	assert(fd >= 0);
+
+	LIST_FOREACH(s, &srv->sessions, next)
+		if (s->ctrl == fd || s->intr == fd || s->vkbd == fd)
+			break;
+
+	return (s);
+}
+
+/*
+ * Close session
+ */
+
+void
+session_close(bthid_session_p s)
+{
+	assert(s != NULL);
+	assert(s->srv != NULL);
+
+	LIST_REMOVE(s, next);
+
+	if (s->intr != -1) {
+		FD_CLR(s->intr, &s->srv->rfdset);
+		FD_CLR(s->intr, &s->srv->wfdset);
+		close(s->intr);
+
+		if (s->srv->maxfd == s->intr)
+			s->srv->maxfd --;
+	}
+
+	if (s->ctrl != -1) {
+		FD_CLR(s->ctrl, &s->srv->rfdset);
+		FD_CLR(s->ctrl, &s->srv->wfdset);
+		close(s->ctrl);
+
+		if (s->srv->maxfd == s->ctrl)
+			s->srv->maxfd --;
+	}
+
+	if (s->vkbd != -1) {
+		FD_CLR(s->vkbd, &s->srv->rfdset);
+		close(s->vkbd);
+
+		if (s->srv->maxfd == s->vkbd)
+			s->srv->maxfd --;
+	}
+
+	free(s->keys1);
+	free(s->keys2);
+
+	memset(s, 0, sizeof(*s));
+	free(s);
+}
+
diff --git a/usr.sbin/btpand/Makefile b/usr.sbin/btpand/Makefile
new file mode 100644
index 0000000000..6dacea4278
--- /dev/null
+++ b/usr.sbin/btpand/Makefile
@@ -0,0 +1,13 @@
+# $NetBSD: Makefile,v 1.2 2008/08/18 08:25:32 plunky Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/btpand/Makefile 187938 2009-01-30 22:23:21Z emax $
+
+PROG=	btpand
+MAN=	btpand.8
+SRCS=	btpand.c bnep.c channel.c client.c event.c packet.c server.c sdp.c tap.c
+
+WARNS?=	3
+
+DPADD+=	${LIBBLUETOOTH} ${LIBSDP} ${LIBUTIL}
+LDADD+=	-lbluetooth -lsdp -lutil
+
+.include <bsd.prog.mk>
